commit 899efdd12a1c79b7bba7bf1c7dcb72645996ab04
Author: freddy77 <freddy77>
Date:   Wed Jun 17 16:20:59 2009 +0000

    fix iconv portability problem

diff --git a/ChangeLog b/ChangeLog
index 99326f8..c847906 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,6 @@
+Wed Jun 17 18:20:53 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/tds/iconv.c: fix iconv portability problem
+
 Fri Jun 12 10:53:39 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* include/tds.h src/odbc/convert_tds2sql.c:
 	* src/odbc/unittests/data.c src/tds/convert.c src/tds/tds_checks.c:
@@ -1648,4 +1651,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2813 2009/06/12 08:53:49 freddy77 Exp $
+$Id: ChangeLog,v 1.2814 2009/06/17 16:20:59 freddy77 Exp $
diff --git a/src/tds/iconv.c b/src/tds/iconv.c
index 5a1afeb..b7c8b3e 100644
--- a/src/tds/iconv.c
+++ b/src/tds/iconv.c
@@ -49,7 +49,7 @@
 /* define this for now; remove when done testing */
 #define HAVE_ICONV_ALWAYS 1
 
-TDS_RCSID(var, "$Id: iconv.c,v 1.137 2009/06/09 08:55:23 freddy77 Exp $");
+TDS_RCSID(var, "$Id: iconv.c,v 1.138 2009/06/17 16:20:59 freddy77 Exp $");
 
 #define CHARSIZE(charset) ( ((charset)->min_bytes_per_char == (charset)->max_bytes_per_char )? \
 				(charset)->min_bytes_per_char : 0 )
@@ -746,9 +746,13 @@ tds_iconv(TDSSOCKET * tds, const TDSICONV * conv, TDS_ICONV_DIRECTION io,
 		}
 		/* iconv success, return */
 		if (irreversible != (size_t) - 1) {
+			/* here we detect end of conversion and try to reset shift state */
 			if (inbuf) {
+				/*
+				 * if inbuf or *inbuf is NULL iconv reset the shift state.
+				 * Note that setting inbytesleft to NULL can cause core so don't do it!
+				 */
 				inbuf = NULL;
-				inbytesleft = 0;
 				continue;
 			}
 			break;

